#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

#include "wiringPi.h"
#include "wiringPiI2C.h"

#define ADR_BASE_8591   (0x90 >> 1)
#define NB_CANAUX 4

int main()
{
   int fd;
   int i2cAddress = ADR_BASE_8591;
   int x;
   float tension;
   const float VDD        = 5.; // 5 Volts
   const int NB_PAS       = 256; // convertisseur 8 bits
   int canal = 0; // entrée CAN n°0
   int config;

   if ((fd = wiringPiI2CSetup(i2cAddress)) < 0)
              return fd ;

   while(1)
   {    
        // cf. doc PCF8591.pdf page 6
        config = 0x00 | canal;
        printf("# config : 0x%02X - canal : %d\n", (unsigned char)config, canal);

        wiringPiI2CWrite(fd, config);

        x = wiringPiI2CRead(fd); // à ignorer (conversion précédente)
        x = wiringPiI2CRead(fd);         
        printf("# data CAN : 0x%02X\n", (unsigned char)x);

        tension = (float)( (float)(x & 0x00FF) * (float)(VDD/NB_PAS) );
        printf("# tension CAN = %2.2fV\n", tension);
      
        printf("\n");
        sleep(2);
   }

   return 0;
}
